/*
Kou speed lines

v1
*/

local RADIUS = 32*FRACUNIT

freeslot("SPR_KFIR", "S_KOU_SPEEDLINE")

states[S_KOU_SPEEDLINE] = {
	sprite = SPR_KFIR,
	frame = FF_PAPERSPRITE|FF_ANIMATE|FF_ADD,
	tics = 8,
	var1 = 3,
	var2 = 2
}

local function SpawnSpeedLine(player)
	local mo = player.mo
	local scale = mo.scale
	local radius = RADIUS
	local height = FixedDiv(mo.height, scale)
	local momz = P_MobjFlip(mo)*mo.momz
	
	local x = FixedMul(P_RandomFixed(), radius << 1) - radius - FixedDiv(mo.momx, scale)
	local y = FixedMul(P_RandomFixed(), radius << 1) - radius - FixedDiv(mo.momy, scale)
	local z = FixedMul(P_RandomFixed(), height) - FixedDiv(momz, scale)
	
	local line = P_SpawnMobjFromMobj(mo, x, y, z, MT_PARTICLE)
	line.state = S_KOU_SPEEDLINE
	line.color = mo.color
	line.angle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	line.rollangle = R_PointToAngle2(0, 0, FixedHypot(mo.momx, mo.momy), momz)
end

rawset(_G, "Kou_SpawnSpeedLine", SpawnSpeedLine)